package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CouponInfo;
import com.izouma.awesomeadmin.service.CouponInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/couponInfo")
@RequiresAuthentication
public class CouponInfoController {

    @Autowired
    private CouponInfoService couponInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CouponInfo record) {
        List<CouponInfo> pp = couponInfoService.getCouponInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getCouponInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getCouponInfo(@RequestParam(required = false, value = "id") String id) {
        CouponInfo data = couponInfoService.getCouponInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CouponInfo record) {
        CouponInfo data = couponInfoService.getCouponInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CouponInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<CouponInfo> pp =couponInfoService.getCouponInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CouponInfo record) {
        boolean num = couponInfoService.createCouponInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCouponInfo(CouponInfo record) {
        boolean num = couponInfoService.updateCouponInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCouponInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = couponInfoService.deleteCouponInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CouponInfo record) throws Exception {

    List<CouponInfo> couponInfos = couponInfoService.getCouponInfoList(record);


        String sheetName = "coupon_info";
        String titleName = "优惠券数据表";
        String fileName = "优惠券表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "描述" ,   "抵扣金额" ,   "限制金额" ,   "类型" ,   "状态" ,   "有效天数"  };
        String[][] dataList = new String[couponInfos.size()][13];

        for (int i = 0; i < couponInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(couponInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(couponInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(couponInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(couponInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(couponInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(couponInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(couponInfos.get(i).getName());
                        dataList[i][7] = String.valueOf(couponInfos.get(i).getDiscription());
                        dataList[i][8] = String.valueOf(couponInfos.get(i).getDiscountMoney());
                        dataList[i][9] = String.valueOf(couponInfos.get(i).getLimitMoney());
                        dataList[i][10] = String.valueOf(couponInfos.get(i).getTypeFlag());
                        dataList[i][11] = String.valueOf(couponInfos.get(i).getStatusFlag());
                        dataList[i][12] = String.valueOf(couponInfos.get(i).getAvailableDays());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

